﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace Enumerable_examples {
   public static class Convert {
      public static string Join(string SeparatorString, IEnumerable List) {
         StringBuilder sb = new StringBuilder();
         bool IterateFlag = false;

         foreach (object o in List) {
            if (IterateFlag) sb.Append(SeparatorString);
            else IterateFlag = true;
            sb.Append(o.ToString());
         }

         return sb.ToString();
      }

      public static string Join(IEnumerable List) {
         return Join("", List);
      }

      public delegate T MapAction<T>(T Input);
      public delegate TOut MapAction<TIn, TOut>(TIn Input);

      public static IEnumerable<T> Map<T>(IEnumerable<T> List, MapAction<T> MapDelegate) {
         foreach (T o in List)
            yield return MapDelegate(o);
         yield break;
      }

      public static IEnumerable<TOut> Map<TIn, TOut>(IEnumerable<TIn> List, MapAction<TIn, TOut> MapDelegate) {
         foreach (TIn o in List)
            yield return MapDelegate(o);
         yield break;
      }

      public static IEnumerable<T> Concat<T>(IEnumerable<T> List1, IEnumerable<T> List2) {
         foreach (T o in List1)
            yield return o;
         foreach (T o in List2)
            yield return o;
         yield break;
      }

      public static IEnumerable<TOut> TypeCast<TIn, TOut>(IEnumerable<TIn> List) where TOut: class {
         foreach (TIn o in List)
            yield return o as TOut;
         yield break;
      }
   }
}
