﻿using System;
using System.Collections.Generic;
using System.IO;

namespace Enumerable_examples {
   public static class IO {
      public static IEnumerable<string> TextStreamReader(Stream Input) {
         StreamReader Reader = new StreamReader(Input);
         while (!Reader.EndOfStream)
            yield return Reader.ReadLine();
         Reader.Close();
         yield break;
      }

      public static IEnumerable<string> TextFileReader(string Pathname) {
         FileStream FileInput = new FileStream(Pathname, FileMode.Open);
         StreamReader Reader = new StreamReader(FileInput);
         while (!Reader.EndOfStream)
            yield return Reader.ReadLine();
         Reader.Close();
         FileInput.Close();
         yield break;
      }
   }
}
