﻿using System;

namespace Enumerable_examples {
   class Program {
      static void Main(string[] args) {
         // Count 1..10
         Console.WriteLine(
            Convert.Join("\n",
               Compute.Range(1, 10)
            )
         );
         Console.WriteLine("---");

         // Count 1..10 and multiply results by 5
         Console.WriteLine(
            Convert.Join("\n",
               Convert.Map<int>(
                  Compute.Range(1, 10),
                  delegate(int x) { return x * 5; }
               )
            )
         );
         Console.WriteLine("---");

         // Count 1..10, but only display >5
         Console.WriteLine(
            Convert.Join("\n",
               Filter.CompareTo(Compute.Range(1, 10), Filter.CompareOperator.GreaterThan, 5)
            )
         );
         Console.WriteLine("---");

         // 10 random numbers
         Console.WriteLine(
            Convert.Join("\n",
               Filter.Splice<int>(
                  Compute.Random(0, 99),
                  10
               )
            )
         );
         Console.WriteLine("---");

         // Read last 10 lines of a file
         Console.WriteLine(
            Convert.Join("\n",
               Filter.Tail<string>(
                  IO.TextFileReader(@"C:\Windows\win.ini"),
                  10
               )
            )
         );

      }
   }
}
